import { NgZone, TemplateRef } from '@angular/core';
import { DialogPosition, MatDialog, MatDialogConfig as _MatDialogConfig, MatDialogRef } from '@angular/material/dialog';
import { ComponentType } from '@angular/cdk/portal';
export interface AnimationOption {
    keyframes?: Keyframe[];
    keyframeAnimationOptions: KeyframeAnimationOptions;
}
export interface MatDialogConfig extends _MatDialogConfig {
    title?: string;
    animation?: {
        to: 'aside' | 'top' | 'bottom' | 'left' | 'right';
        incomingOptions?: {
            keyframes?: Keyframe[];
            keyframeAnimationOptions: KeyframeAnimationOptions;
        };
        outgoingOptions?: {
            keyframes?: Keyframe[];
            keyframeAnimationOptions: KeyframeAnimationOptions;
        };
    } | {
        to?: 'aside' | 'top' | 'bottom' | 'left' | 'right';
        incomingOptions?: {
            keyframes: Keyframe[];
            keyframeAnimationOptions: KeyframeAnimationOptions;
        };
        outgoingOptions?: {
            keyframes: Keyframe[];
            keyframeAnimationOptions: KeyframeAnimationOptions;
        };
    };
    position?: DialogPosition & {
        rowStart?: string;
        rowEnd?: string;
    };
}
export declare class NgDialogAnimationService {
    private dialog;
    private ngZone;
    private incomingOptions?;
    private outgoingOptions?;
    constructor(dialog: MatDialog, ngZone: NgZone, incomingOptions?: AnimationOption, outgoingOptions?: AnimationOption);
    open<T, D = any, R = any>(componentOrTemplateRef: ComponentType<T> | TemplateRef<T>, config?: MatDialogConfig): MatDialogRef<T, R>;
}
